using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.IO;
using System.Net.Sockets;
using BlueLibs;
using BlueLibs.Comm;
using BlueLibs.OBEX;
using BlueLibs.Components;

namespace OBEXFtpClient
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
    public class Form1 : System.Windows.Forms.Form
    {
        private System.ComponentModel.IContainer components = null;
        private System.Windows.Forms.Button button3;
        private BlueLibs.Components.BTDeviceList btDeviceList1;
        private BlueLibs.Components.OBEXFtpConnection obexFtpConnection1;
        private BlueLibs.Components.OBEXFtpDirList obexFtpDirList1;
        private System.Windows.Forms.ListView listView1;
        private System.Windows.Forms.ColumnHeader columnHeader1;
        private System.Windows.Forms.ColumnHeader columnHeader2;
        private System.Windows.Forms.ColumnHeader columnHeader3;
        private System.Windows.Forms.ColumnHeader columnHeader4;
        private System.Windows.Forms.ColumnHeader columnHeader5;
        private System.Windows.Forms.Button button4;
        private System.Windows.Forms.Button button5;
        private System.Windows.Forms.Button button6;
        private System.Windows.Forms.TextBox textBox1;
        private System.Windows.Forms.Panel panel1;
        private System.Windows.Forms.NumericUpDown numericUpDown1;
        private System.Windows.Forms.Label label3;
        private System.Windows.Forms.Button button1;
        private System.Windows.Forms.ComboBox comboBox1;
        private System.Windows.Forms.Label label1;
        private System.Windows.Forms.Label label4;
        private BlueLibs.Components.BTScanner btScanner1;
        private System.Windows.Forms.Button button7;
        private System.Windows.Forms.ProgressBar progressBar1;
        private System.Windows.Forms.ImageList imageList1;
        private BlueLibs.Components.BTServiceList btServiceList1;
        private System.Windows.Forms.ComboBox comboBox2;
        private System.Windows.Forms.Button button2;
        private System.Windows.Forms.Label label2;
        private System.Windows.Forms.Button button8;
        private BlueLibs.Components.BTDevice btDevice1;

        public ArrayList BTDevices = new ArrayList();

        public Form1()
        {
            //
            // Required for Windows Form Designer support
            //
            InitializeComponent();

            //
            // TODO: Add any constructor code after InitializeComponent call
            //
        }

        /// <summary>
        /// Clean up any resources being used.
        /// </summary>
        protected override void Dispose( bool disposing )
        {
            if( disposing )
            {
                if (components != null) 
                {
                    components.Dispose();
                }
            }
            base.Dispose( disposing );
        }

        #region Windows Form Designer generated code
        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent()
        {
            this.components = new System.ComponentModel.Container();
            System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Form1));
            this.btDeviceList1 = new BlueLibs.Components.BTDeviceList(this.components);
            this.btScanner1 = new BlueLibs.Components.BTScanner(this.components);
            this.button3 = new System.Windows.Forms.Button();
            this.obexFtpDirList1 = new BlueLibs.Components.OBEXFtpDirList(this.components);
            this.obexFtpConnection1 = new BlueLibs.Components.OBEXFtpConnection();
            this.btDevice1 = new BlueLibs.Components.BTDevice(this.components);
            this.listView1 = new System.Windows.Forms.ListView();
            this.columnHeader1 = new System.Windows.Forms.ColumnHeader();
            this.columnHeader2 = new System.Windows.Forms.ColumnHeader();
            this.columnHeader3 = new System.Windows.Forms.ColumnHeader();
            this.columnHeader4 = new System.Windows.Forms.ColumnHeader();
            this.columnHeader5 = new System.Windows.Forms.ColumnHeader();
            this.imageList1 = new System.Windows.Forms.ImageList(this.components);
            this.button4 = new System.Windows.Forms.Button();
            this.button5 = new System.Windows.Forms.Button();
            this.button6 = new System.Windows.Forms.Button();
            this.textBox1 = new System.Windows.Forms.TextBox();
            this.panel1 = new System.Windows.Forms.Panel();
            this.comboBox2 = new System.Windows.Forms.ComboBox();
            this.btServiceList1 = new BlueLibs.Components.BTServiceList(this.components);
            this.label2 = new System.Windows.Forms.Label();
            this.button2 = new System.Windows.Forms.Button();
            this.numericUpDown1 = new System.Windows.Forms.NumericUpDown();
            this.label3 = new System.Windows.Forms.Label();
            this.button1 = new System.Windows.Forms.Button();
            this.comboBox1 = new System.Windows.Forms.ComboBox();
            this.label1 = new System.Windows.Forms.Label();
            this.button7 = new System.Windows.Forms.Button();
            this.label4 = new System.Windows.Forms.Label();
            this.progressBar1 = new System.Windows.Forms.ProgressBar();
            this.button8 = new System.Windows.Forms.Button();
            this.panel1.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.numericUpDown1)).BeginInit();
            this.SuspendLayout();
            // 
            // btDeviceList1
            // 
            this.btDeviceList1.Scanner = this.btScanner1;
            // 
            // button3
            // 
            this.button3.Image = ((System.Drawing.Image)(resources.GetObject("button3.Image")));
            this.button3.ImageAlign = System.Drawing.ContentAlignment.BottomLeft;
            this.button3.Location = new System.Drawing.Point(216, 32);
            this.button3.Name = "button3";
            this.button3.Size = new System.Drawing.Size(112, 23);
            this.button3.TabIndex = 10;
            this.button3.Text = "Connect FTP";
            this.button3.TextAlign = System.Drawing.ContentAlignment.BottomCenter;
            this.button3.Click += new System.EventHandler(this.button3_Click);
            // 
            // obexFtpDirList1
            // 
            this.obexFtpDirList1.Connection = this.obexFtpConnection1;
            this.obexFtpDirList1.ListChanged += new System.ComponentModel.ListChangedEventHandler(this.obexFtpDirList1_ListChanged);
            // 
            // obexFtpConnection1
            // 
            this.obexFtpConnection1.Device = this.btDevice1;
            this.obexFtpConnection1.OnReceiveFileProgress += new BlueLibs.Components.ReceiveFileProgressDelegate(this.obexFtpConnection1_OnReceiveFileProgress);
            this.obexFtpConnection1.OnSendFileProgress += new BlueLibs.Components.SendFileProgressDelegate(this.obexFtpConnection1_OnSendFileProgress);
            // 
            // btDevice1
            // 
            this.btDevice1.Scanner = this.btScanner1;
            this.btDevice1.OnSelectedDeviceChanged += new System.EventHandler(this.btDevice1_OnSelectedDeviceChanged);
            // 
            // listView1
            // 
            this.listView1.BackColor = System.Drawing.SystemColors.Window;
            this.listView1.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
                                                                                        this.columnHeader1,
                                                                                        this.columnHeader2,
                                                                                        this.columnHeader3,
                                                                                        this.columnHeader4,
                                                                                        this.columnHeader5});
            this.listView1.FullRowSelect = true;
            this.listView1.LabelWrap = false;
            this.listView1.Location = new System.Drawing.Point(336, 7);
            this.listView1.Name = "listView1";
            this.listView1.Size = new System.Drawing.Size(576, 313);
            this.listView1.SmallImageList = this.imageList1;
            this.listView1.TabIndex = 12;
            this.listView1.View = System.Windows.Forms.View.Details;
            this.listView1.DoubleClick += new System.EventHandler(this.listView1_DoubleClick);
            this.listView1.SelectedIndexChanged += new System.EventHandler(this.listView1_SelectedIndexChanged);
            // 
            // columnHeader1
            // 
            this.columnHeader1.Text = "Name";
            this.columnHeader1.Width = 185;
            // 
            // columnHeader2
            // 
            this.columnHeader2.Text = "Size";
            this.columnHeader2.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
            this.columnHeader2.Width = 80;
            // 
            // columnHeader3
            // 
            this.columnHeader3.Text = "Created";
            this.columnHeader3.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
            this.columnHeader3.Width = 121;
            // 
            // columnHeader4
            // 
            this.columnHeader4.Text = "Modified";
            this.columnHeader4.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
            this.columnHeader4.Width = 111;
            // 
            // columnHeader5
            // 
            this.columnHeader5.Text = "User-Perms";
            this.columnHeader5.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
            this.columnHeader5.Width = 71;
            // 
            // imageList1
            // 
            this.imageList1.ImageSize = new System.Drawing.Size(16, 16);
            this.imageList1.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList1.ImageStream")));
            this.imageList1.TransparentColor = System.Drawing.Color.Transparent;
            // 
            // button4
            // 
            this.button4.Enabled = false;
            this.button4.Location = new System.Drawing.Point(224, 256);
            this.button4.Name = "button4";
            this.button4.Size = new System.Drawing.Size(101, 23);
            this.button4.TabIndex = 13;
            this.button4.Text = "Put file";
            this.button4.Click += new System.EventHandler(this.button4_Click);
            // 
            // button5
            // 
            this.button5.Enabled = false;
            this.button5.Location = new System.Drawing.Point(224, 160);
            this.button5.Name = "button5";
            this.button5.Size = new System.Drawing.Size(101, 23);
            this.button5.TabIndex = 14;
            this.button5.Text = "Create Directory";
            this.button5.Click += new System.EventHandler(this.button5_Click);
            // 
            // button6
            // 
            this.button6.Enabled = false;
            this.button6.Location = new System.Drawing.Point(224, 224);
            this.button6.Name = "button6";
            this.button6.Size = new System.Drawing.Size(101, 23);
            this.button6.TabIndex = 15;
            this.button6.Text = "Remove";
            this.button6.Click += new System.EventHandler(this.button6_Click);
            // 
            // textBox1
            // 
            this.textBox1.Enabled = false;
            this.textBox1.Location = new System.Drawing.Point(224, 128);
            this.textBox1.Name = "textBox1";
            this.textBox1.TabIndex = 16;
            this.textBox1.Text = "";
            this.textBox1.TextChanged += new System.EventHandler(this.textBox1_TextChanged);
            // 
            // panel1
            // 
            this.panel1.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.panel1.Controls.Add(this.comboBox2);
            this.panel1.Controls.Add(this.label2);
            this.panel1.Controls.Add(this.button2);
            this.panel1.Controls.Add(this.numericUpDown1);
            this.panel1.Controls.Add(this.label3);
            this.panel1.Controls.Add(this.button1);
            this.panel1.Controls.Add(this.comboBox1);
            this.panel1.Controls.Add(this.label1);
            this.panel1.Controls.Add(this.button7);
            this.panel1.Location = new System.Drawing.Point(8, 8);
            this.panel1.Name = "panel1";
            this.panel1.Size = new System.Drawing.Size(200, 272);
            this.panel1.TabIndex = 17;
            // 
            // comboBox2
            // 
            this.comboBox2.DataSource = this.btServiceList1;
            this.comboBox2.DisplayMember = "Name";
            this.comboBox2.Location = new System.Drawing.Point(8, 200);
            this.comboBox2.Name = "comboBox2";
            this.comboBox2.Size = new System.Drawing.Size(176, 21);
            this.comboBox2.TabIndex = 20;
            this.comboBox2.ValueMember = "ServiceID";
            // 
            // btServiceList1
            // 
            this.btServiceList1.Device = this.btDevice1;
            // 
            // label2
            // 
            this.label2.Location = new System.Drawing.Point(16, 184);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(152, 23);
            this.label2.TabIndex = 22;
            this.label2.Text = "BT device services:";
            // 
            // button2
            // 
            this.button2.Location = new System.Drawing.Point(8, 232);
            this.button2.Name = "button2";
            this.button2.Size = new System.Drawing.Size(176, 23);
            this.button2.TabIndex = 21;
            this.button2.Text = "Get BT device services";
            this.button2.Click += new System.EventHandler(this.button2_Click);
            // 
            // numericUpDown1
            // 
            this.numericUpDown1.Location = new System.Drawing.Point(120, 62);
            this.numericUpDown1.Maximum = new System.Decimal(new int[] {
                                                                           254,
                                                                           0,
                                                                           0,
                                                                           0});
            this.numericUpDown1.Minimum = new System.Decimal(new int[] {
                                                                           1,
                                                                           0,
                                                                           0,
                                                                           -2147483648});
            this.numericUpDown1.Name = "numericUpDown1";
            this.numericUpDown1.Size = new System.Drawing.Size(56, 20);
            this.numericUpDown1.TabIndex = 17;
            this.numericUpDown1.Value = new System.Decimal(new int[] {
                                                                         1,
                                                                         0,
                                                                         0,
                                                                         0});
            // 
            // label3
            // 
            this.label3.Location = new System.Drawing.Point(8, 64);
            this.label3.Name = "label3";
            this.label3.Size = new System.Drawing.Size(112, 23);
            this.label3.TabIndex = 18;
            this.label3.Text = "Search timeout [sec]:";
            // 
            // button1
            // 
            this.button1.Location = new System.Drawing.Point(8, 104);
            this.button1.Name = "button1";
            this.button1.Size = new System.Drawing.Size(176, 23);
            this.button1.TabIndex = 13;
            this.button1.Text = "Get BT devices";
            this.button1.Click += new System.EventHandler(this.button1_Click);
            // 
            // comboBox1
            // 
            this.comboBox1.DataSource = this.btDeviceList1;
            this.comboBox1.DisplayMember = "Name";
            this.comboBox1.Location = new System.Drawing.Point(8, 24);
            this.comboBox1.Name = "comboBox1";
            this.comboBox1.Size = new System.Drawing.Size(176, 21);
            this.comboBox1.TabIndex = 11;
            this.comboBox1.ValueMember = "Address";
            // 
            // label1
            // 
            this.label1.Location = new System.Drawing.Point(12, 8);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(64, 16);
            this.label1.TabIndex = 10;
            this.label1.Text = "BT devices:";
            // 
            // button7
            // 
            this.button7.Location = new System.Drawing.Point(8, 136);
            this.button7.Name = "button7";
            this.button7.Size = new System.Drawing.Size(176, 23);
            this.button7.TabIndex = 19;
            this.button7.Text = "Select device";
            this.button7.Click += new System.EventHandler(this.button7_Click);
            // 
            // label4
            // 
            this.label4.Enabled = false;
            this.label4.Location = new System.Drawing.Point(224, 112);
            this.label4.Name = "label4";
            this.label4.Size = new System.Drawing.Size(112, 16);
            this.label4.TabIndex = 18;
            this.label4.Text = "New directory name:";
            // 
            // progressBar1
            // 
            this.progressBar1.Location = new System.Drawing.Point(8, 296);
            this.progressBar1.Name = "progressBar1";
            this.progressBar1.Size = new System.Drawing.Size(320, 23);
            this.progressBar1.TabIndex = 20;
            this.progressBar1.Visible = false;
            // 
            // button8
            // 
            this.button8.Enabled = false;
            this.button8.Location = new System.Drawing.Point(224, 192);
            this.button8.Name = "button8";
            this.button8.Size = new System.Drawing.Size(101, 23);
            this.button8.TabIndex = 21;
            this.button8.Text = "To parent dir";
            this.button8.Click += new System.EventHandler(this.button8_Click);
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(920, 333);
            this.Controls.Add(this.button8);
            this.Controls.Add(this.progressBar1);
            this.Controls.Add(this.label4);
            this.Controls.Add(this.panel1);
            this.Controls.Add(this.textBox1);
            this.Controls.Add(this.button6);
            this.Controls.Add(this.button5);
            this.Controls.Add(this.button4);
            this.Controls.Add(this.listView1);
            this.Controls.Add(this.button3);
            this.Name = "Form1";
            this.Text = "BT FTP Client sample";
            this.panel1.ResumeLayout(false);
            ((System.ComponentModel.ISupportInitialize)(this.numericUpDown1)).EndInit();
            this.ResumeLayout(false);

        }
        #endregion

        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        [STAThread]
        static void Main() 
        {
            Application.Run(new Form1());
        }

        private void button1_Click(object sender, System.EventArgs e)
        {   
            btScanner1.SearchTime = (double)numericUpDown1.Value;
            btDeviceList1.EnumDevices();
        }
    
        private void button7_Click(object sender, System.EventArgs e)
        {
            if ((comboBox1.SelectedIndex>=0) && (comboBox1.SelectedIndex<btDeviceList1.Count))
               btDevice1.SelectedDevice = (RemoteDevice)btDeviceList1[comboBox1.SelectedIndex];
        }

        private System.Drawing.Image GetResImage(string ResName)
        {
            System.Reflection.Assembly myAssembly = this.GetType().Assembly;
            System.Resources.ResourceManager myManager = new 
                System.Resources.ResourceManager(myAssembly.GetName().Name+".ImgRes", myAssembly);
            return (System.Drawing.Image)myManager.GetObject(ResName);
        }

        private void UpdateForm()
        {
            bool IsEn = obexFtpConnection1.Connected;
            button4.Enabled = IsEn;
            button5.Enabled = IsEn && (textBox1.Text.CompareTo("")!=0);
            button6.Enabled = IsEn && (listView1.SelectedItems.Count>0);
            button8.Enabled = IsEn;
            label4.Enabled = IsEn;
            textBox1.Enabled = IsEn;
            if (IsEn) 
            {
                button3.Text = "Disconnect FTP";
                button3.Image = GetResImage("BULBON");
                button3.TextAlign = ContentAlignment.BottomRight;
            }
            else 
            {
                button3.Text = "Connect FTP";
                button3.Image = GetResImage("BULBOFF");
                button3.TextAlign = ContentAlignment.BottomCenter;
            }
        }

        private void button3_Click(object sender, System.EventArgs e)
        {
            
            try
            {
                Cursor = Cursors.WaitCursor;
                try
                {
                    obexFtpConnection1.Connected = !obexFtpConnection1.Connected;
                }
                finally
                {
                    UpdateForm();
                    Cursor = Cursors.Default;
                }
            }
            catch (Exception err)
            {
                MessageBox.Show(err.Message);
            }
        }

        private void obexFtpDirList1_ListChanged(object sender, System.ComponentModel.ListChangedEventArgs e)
        {
            listView1.Items.Clear();
            foreach(OBEXFtpDirItem AnItem in obexFtpDirList1)
            {
                ListViewItem ALVItem = new ListViewItem(AnItem.Name);
                ALVItem.Tag = AnItem;
                if (AnItem is OBEXFtpFile) ALVItem.ImageIndex = 1; else ALVItem.ImageIndex = 0;
                if ((AnItem is OBEXFtpFileFolderItem) && !(AnItem is OBEXFtpParentFolder)) 
                {
                    ListViewItem.ListViewSubItem ALVSItem = new ListViewItem.ListViewSubItem();
                    ALVSItem.Text = ((OBEXFtpFileFolderItem)AnItem).Size.ToString(); 
                    ALVItem.SubItems.Add(ALVSItem);
                    ALVSItem = new ListViewItem.ListViewSubItem();
                    ALVSItem.Text = ((OBEXFtpFileFolderItem)AnItem).Created.ToString();
                    ALVItem.SubItems.Add(ALVSItem);
                    ALVSItem = new ListViewItem.ListViewSubItem();
                    ALVSItem.Text = ((OBEXFtpFileFolderItem)AnItem).Modified.ToString();
                    ALVItem.SubItems.Add(ALVSItem);
                    ALVSItem = new ListViewItem.ListViewSubItem();
                    ALVSItem.Text = ((OBEXFtpFileFolderItem)AnItem).UserPerms.ToString();
                    ALVItem.SubItems.Add(ALVSItem);
                }
                listView1.Items.Add(ALVItem);
            }
            bool IsEn = obexFtpConnection1.Connected && (listView1.SelectedItems.Count>0);
            button6.Enabled = IsEn;
        }

        private void listView1_DoubleClick(object sender, System.EventArgs e)
        {
            
            ListViewItem AnItem = listView1.FocusedItem;
            if (AnItem.Tag is OBEXFtpFolder)
            {
                Cursor = Cursors.WaitCursor;
                try
                {
                    obexFtpConnection1.ChangeDir(((OBEXFtpFolder)AnItem.Tag).Name);
                }
                finally
                {
                    Cursor = Cursors.Default;
                }
            }
            else if (AnItem.Tag is OBEXFtpParentFolder) 
            {
                Cursor = Cursors.WaitCursor;
                try
                {
                    obexFtpConnection1.DirUp();
                }
                finally
                {
                    Cursor = Cursors.Default;
                }
            }
            else if (AnItem.Tag is OBEXFtpFile) 
            {
                string AFileName = ((OBEXFtpFile)AnItem.Tag).Name;
                MemoryStream Stm = null;
                Cursor = Cursors.WaitCursor;
                progressBar1.Minimum = 0; 
                progressBar1.Maximum = 0;
                progressBar1.Value = 0;
                progressBar1.Visible = true;
                Application.DoEvents();
                try
                {
                    Stm = obexFtpConnection1.GetFile(AFileName);
                }
                finally
                {
                    progressBar1.Value = 0;
                    progressBar1.Visible = false;
                    Cursor = Cursors.Default;
                }

                SaveFileDialog ADlg  = new SaveFileDialog();
                ADlg.FileName = AFileName;
                if (DialogResult.OK == ADlg.ShowDialog())
                {
                    FileStream sw = new FileStream(ADlg.FileName,FileMode.Create);
                    try
                    {
                        Stm.WriteTo(sw);
                        sw.Flush();
                    }
                    finally
                    {
                        sw.Close();
                    }
                }
            }
        }
        /*
        internal class ProcessFileSend
        {
            FileInfo ffi;
            OBEXFtpConnection fconn;
            public ProcessFileSend(OBEXFtpConnection conn, FileInfo afi)
            {
                fconn = conn;
                ffi = afi;
            }
            public void DoProcess()
            {
                fconn.PutFile(ffi);
            }
        }
        */
        private void button4_Click(object sender, System.EventArgs e)
        {
            OpenFileDialog ADlg = new OpenFileDialog();
            ADlg.Filter = "All files (*.*)|*.*";

            if (ADlg.ShowDialog() == DialogResult.OK)
            {
                Cursor = Cursors.WaitCursor;
                progressBar1.Visible = true;
                progressBar1.Minimum = 0;
                progressBar1.Value = 0;
                Application.DoEvents();
                try
                {
                    /*
                    ProcessFileSend pt = new ProcessFileSend(obexFtpConnection1, new FileInfo(ADlg.FileName));
                    System.Threading.Thread th = new System.Threading.Thread(new System.Threading.ThreadStart(pt.DoProcess));
                    th.Start();
                    MessageBox.Show("OK");
                    */
                    obexFtpConnection1.PutFile(new FileInfo(ADlg.FileName));
                }
                finally
                {
                    progressBar1.Value = 0;
                    progressBar1.Visible = false;
                    Cursor = Cursors.Default;
                }
            }
        }

        private void button6_Click(object sender, System.EventArgs e)
        {
            Cursor = Cursors.WaitCursor;
            try
            {
                ListViewItem AnItem = listView1.FocusedItem;
                if (AnItem.Tag is OBEXFtpFile)
                    obexFtpConnection1.Remove(((OBEXFtpFile)AnItem.Tag).Name);
                else if (AnItem.Tag is OBEXFtpFolder)
                    obexFtpConnection1.RemoveDir(((OBEXFtpFolder)AnItem.Tag).Name);
            }
            finally
            {
                Cursor = Cursors.Default;
            }
        }

        private void button5_Click(object sender, System.EventArgs e)
        {
            Cursor = Cursors.WaitCursor;
            try
            {
                obexFtpConnection1.CreateDir(textBox1.Text);
            }
            finally
            {
                Cursor = Cursors.Default;
            }
        }

        private void obexFtpConnection1_OnSendFileProgress(object Sender, int SentBytes, int TotalBytes)
        {
           /* if (InvokeRequired)
            {
                Invoke(new SendFileProgressDelegate(obexFtpConnection1_OnSendFileProgress), new object[] {Sender, SentBytes, TotalBytes});
            } 
            else 
            {
                progressBar1.Maximum = TotalBytes;
                progressBar1.Value = SentBytes;
                progressBar1.Refresh();
                Application.DoEvents();
            } */
            progressBar1.Maximum = TotalBytes;
            progressBar1.Value = SentBytes;
            progressBar1.Refresh();
            Application.DoEvents();
        }

        private void obexFtpConnection1_OnReceiveFileProgress(object Sender, int RecvBytes, int TotalBytes)
        {
            progressBar1.Maximum = TotalBytes;
            progressBar1.Value = RecvBytes;
            progressBar1.Refresh();
            Application.DoEvents();
        }

        private void textBox1_TextChanged(object sender, System.EventArgs e)
        {
            bool IsEn = obexFtpConnection1.Connected && (textBox1.Text.CompareTo("")!=0);
            button5.Enabled = IsEn;
        }

        private void listView1_SelectedIndexChanged(object sender, System.EventArgs e)
        {
            bool IsEn = obexFtpConnection1.Connected && (listView1.SelectedItems.Count>0);
            button6.Enabled = IsEn;
        }

        private void button2_Click(object sender, System.EventArgs e)
        {
            btServiceList1.GetDeviceServices();
        }

        private void button8_Click(object sender, System.EventArgs e)
        {
            Cursor = Cursors.WaitCursor;
            try
            {
                obexFtpConnection1.DirUp();
            }
            finally
            {
                Cursor = Cursors.Default;
            }
        }

        private void btDevice1_OnSelectedDeviceChanged(object sender, System.EventArgs e)
        {
           UpdateForm();
        }
       
    }
}
